package com.mobvcasting.captureviaintent;

import java.io.File;
import java.io.FileNotFoundException;

import android.app.Activity;
import android.content.ContentValues;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore.Images.Media;
import android.view.Display;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;

public class CaptureViaIntent extends Activity implements OnClickListener {

	public static final int CAMERA_RESULT = 1;
	
	Button myButton;
	Uri imageFileUri;
	File imageFile;
	
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        
		ContentValues contentValues = new ContentValues(3); 

		contentValues.put(Media.DISPLAY_NAME, "This is a test title"); 
		contentValues.put(Media.DESCRIPTION, "This is a test description"); 
		contentValues.put(Media.MIME_TYPE, "image/jpeg");

		imageFileUri = getContentResolver().insert( 
		android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI, contentValues);		

		
		
		/*
        imageFile = new File(
        		Environment.getExternalStorageDirectory().getAbsolutePath() + "/myfavoritepicture.jpg"
        		); 
        imageFileUri = Uri.fromFile(imageFile);        
        */
		
        myButton = (Button) this.findViewById(R.id.Button01);
        myButton.setOnClickListener(this);
        
    }

	public void onClick(View v) {
		if (v == myButton) {
			Intent i = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE); 
			i.putExtra(android.provider.MediaStore.EXTRA_OUTPUT, imageFileUri);

			startActivityForResult(i, CAMERA_RESULT);
		}
	}
	
	
	protected void onActivityResult(int requestCode, 
			int resultCode, Intent intent) {
			if (requestCode == CAMERA_RESULT) {
				if (resultCode == Activity.RESULT_OK) {
					try {

					/*
					Bundle extras = intent.getExtras(); 
					Bitmap bmp = (Bitmap) extras.get("data");
					*/
					
					/*
					BitmapFactory.Options bmpFactoryOptions = new BitmapFactory.Options(); 
					bmpFactoryOptions.inSampleSize = 8; 
					Bitmap bmp = BitmapFactory.decodeFile(imageFile.getAbsolutePath(), bmpFactoryOptions);
					*/
					
					
					BitmapFactory.Options bmpFactoryOptions = new BitmapFactory.Options(); 
					bmpFactoryOptions.inJustDecodeBounds = true; 
					
					Bitmap bmp;
						bmp = BitmapFactory.decodeStream(
								getContentResolver().openInputStream(imageFileUri), null, bmpFactoryOptions);
					//Bitmap bmp = BitmapFactory.decodeFile(imageFile.getAbsolutePath(), bmpFactoryOptions);

					Display currentDisplay = getWindowManager().getDefaultDisplay(); 
					int heightRatio = (int)Math.ceil(bmpFactoryOptions.outHeight/(float)currentDisplay.getHeight()); 
					int widthRatio = (int)Math.ceil(bmpFactoryOptions.outWidth/(float)currentDisplay.getWidth());
					
					
					if (heightRatio > 1 && widthRatio > 1) {
						if (heightRatio > widthRatio) {
							bmpFactoryOptions.inSampleSize = heightRatio; 
						} else {
							bmpFactoryOptions.inSampleSize = widthRatio;
						}
					}
					bmpFactoryOptions.inJustDecodeBounds = false; 

						bmp = BitmapFactory.decodeStream(
								getContentResolver().openInputStream(imageFileUri), null, bmpFactoryOptions);
					//bmp = BitmapFactory.decodeFile(imageFile.getAbsolutePath(), bmpFactoryOptions);					
					
					
					
					ImageView iv = (ImageView) this.findViewById(R.id.ImageView01);
					iv.setImageBitmap(bmp);
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
					
				}
			}
	}
	
	
}